<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Registros del sistema</strong>
    </div>
    <!--Contenido-->
    <div class="pl-10 pr-10 contSecc">
      <div class="center">
        <v-row>
          <v-col class="pt-0 pb-0" cols="6">
            <v-card class="mx-auto pa-2">
              <div>
                <v-text-field
                  v-model="search"
                  label="Buscar archivos de registro"
                  hide-details
                  clearable
                  clear-icon="mdi-close-circle-outline"
                ></v-text-field>
              </div>
              <v-card-title>
                <v-icon>
                  mdi-server
                </v-icon>
                Lista de nodos
                <v-btn
                  class="ma-2"
                  dark
                  tile
                  depressed
                  right
                  absolute
                  color="secondary"
                  @click="getListFiles()"
                >
                  Refrescar
                  <v-icon>mdi-sync</v-icon>
                </v-btn>
              </v-card-title>
              <v-treeview
                :loading="loading"
                :active.sync="selection"
                :items="items"
                :search="search"
                :filter="filter"
                :open.sync="open"
                :open-all="openAll"
                activatable
                item-key="last_modified_time"
                item-text="value"
                item-children="items"
                open-on-click
                return-object
                style="overflow: auto; max-height: 400px; min-height: 400px;"
              >
                <template v-slot:prepend="{ item, open }">
                  <v-icon v-if="!item.file">
                    {{ open ? "mdi-folder-open" : "mdi-folder" }}
                  </v-icon>
                  <v-icon v-else>
                    {{ files.json }}
                  </v-icon>
                </template>
              </v-treeview>
            </v-card>
          </v-col>
          <v-divider vertical></v-divider>
          <v-col class="pt-0 pb-0" cols="6">
            <v-card class="mx-auto pa-2" min-height="526" max-height="526">
              <template v-if="!selection.length">
                Seleccione un archivo
              </template>
              <template v-else>
                <v-text-field
                  v-model="searchLog"
                  label="Buscar contenido en el registro"
                  hide-details
                  clearable
                  clear-icon="mdi-close-circle-outline"
                ></v-text-field>
                <v-card-title>
                  <v-icon>
                    {{ files.json }}
                  </v-icon>
                  {{ selection[0].value }}
                  <v-btn
                    class="ma-2"
                    dark
                    tile
                    depressed
                    right
                    absolute
                    color="secondary"
                    @click="getFile()"
                  >
                    Refrescar
                    <v-icon>mdi-sync</v-icon>
                  </v-btn>
                </v-card-title>
                <div
                  style="overflow: auto; max-height: 400px; min-height: 400px;"
                >
                  <template v-if="refreshComponent">
                    <json-viewer
                      :value="contentFileFilter"
                      :expand-depth="5"
                      theme="my-awesome-json-theme"
                      :copyable="{
                        copyText: 'Copiar',
                        copiedText: 'Copiado',
                        timeout: 2000,
                      }"
                      expanded
                    />
                  </template>
                </div>
              </template>
            </v-card>
          </v-col>
        </v-row>
      </div>
    </div>
  </div>
</template>
<style lang="scss">
.my-awesome-json-theme {
  background: white;
  white-space: nowrap;
  color: #3c3c3c;
  font-size: 14px;
  font-family: Rubik, Arial, sans-serif;

  .jv-ellipsis {
    color: #999;
    background-color: #eee;
    display: inline-block;
    line-height: 0.9;
    font-size: 0.9em;
    padding: 0px 4px 2px 4px;
    border-radius: 3px;
    vertical-align: 2px;
    cursor: pointer;
    user-select: none;
  }
  .jv-button {
    color: #49b3ff;
  }
  .jv-key {
    color: #3c67ab;
    display: inline-block;
    margin-bottom: 5px;
    margin-right: 5px;
    font-weight: 600;
  }
  .jv-item {
    &.jv-array {
      color: #3c67ab;
    }
    &.jv-boolean {
      color: #ea940d;
    }
    &.jv-function {
      color: #3c67ab;
    }
    &.jv-number {
      color: #10bb61;
    }
    &.jv-number-float {
      color: #10bb61;
    }
    &.jv-number-integer {
      color: #10bb61;
    }
    &.jv-object {
      color: #3c67ab;
    }
    &.jv-undefined {
      color: #ea940d;
    }
    &.jv-string {
      color: #3c3c3c;
      word-break: break-word;
      white-space: normal;
    }
  }
  .jv-code {
    .jv-toggle {
      color: #5f6a74;
      &:before {
        padding: 0px 2px;
        border-radius: 2px;
      }
      &:hover {
        &:before {
          background: #eee;
        }
      }
    }
  }
  .jv-button {
    position: relative;
    display: inline-flex;
    justify-content: center;
    align-items: center;
    border: 1px solid transparent;
    border-radius: 2px;
    line-height: 1;
    text-align: center;
    text-decoration: none;
    overflow: hidden;
    background-color: transparent;
    border-color: #3c67ab;
    color: #3c67ab;
    z-index: 0;
    cursor: pointer;
    -webkit-transition: all 0.2s ease-in-out;
    -o-transition: all 0.2s ease-in-out;
    transition: all 0.2s ease-in-out;
    padding: 4px 16px;
    font-size: 14px;
    min-height: 24px;
  }
}
</style>
<script>
import axios from "axios";
import mark from "mark.js";
let instanceMark;
export default {
  name: "Component-Registros",
  data() {
    return {
      selection: [],
      open: [],
      openAll: true,
      search: null,
      searchLog: null,
      caseSensitive: false,
      loading: false,
      refreshComponent: true,
      queries: ["timeMillis"],
      files: {
        json: "mdi-code-json",
        txt: "mdi-file-document-outline",
      },
      items: [],
      contentFile: [],
      contentFileFilter: [],
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Soporte",
          disabled: false,
          exact: true,
          to: {
            name: "soporte",
          },
        },
        {
          text: "Monitoreo",
          disabled: false,
          exact: true,
          to: {
            name: "soporte_monitoreo",
          },
        },
        {
          text: "Registros del sistema",
          disabled: true,
        },
      ],
    };
  },
  computed: {
    filter() {
      return this.caseSensitive
        ? (item, search, textKey) => item[textKey].indexOf(search) > -1
        : undefined;
    },
  },
  watch: {
    selection(val) {
      if (val && val.length) {
        this.getFile();
      }
    },
    searchLog(val) {
      this.refreshComponent = false;
      let tempData = this.contentFile;
      this.contentFileFilter = [];
      if (this.searchLog != "" && this.searchLog) {
        tempData = tempData.filter((item) => {
          let wordkeys = [];
          let childValues = [];
          let values = Object.values(item).map((value, index) => {
            if (typeof value !== "object") {
              return (value + "").toUpperCase();
            } else {
              childValues = childValues.concat(
                Object.values(value).map((itemValue) => {
                  return (itemValue + "").toUpperCase();
                })
              );
              return "";
            }
          });
          wordkeys = wordkeys.concat(values);
          wordkeys = wordkeys.concat(childValues);
          let wordkeysJoined = wordkeys.join(" ");
          return wordkeysJoined.includes(this.searchLog.toUpperCase());
        });
      }
      this.contentFileFilter = tempData;
      setTimeout(() => {
        this.refreshComponent = true;
        setTimeout(() => {
          instanceMark = new mark(
            document.querySelector(".my-awesome-json-theme")
          );
          instanceMark.unmark();
          instanceMark.mark(this.searchLog);
        }, 300);
      }, 100);
    },
  },
  methods: {
    getListFiles() {
      this.loading = true;
      let body = {
        base_path_logs: "/franquicia/plataforma_franquicia/core/logs",
      };
      axios
        .post("/server/logs/secure/get/bd/logs", body)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                this.items = data.items;
              }
            }
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            this.data = [];
          } else {
            console.log(error);
          }
        })
        .finally(() => {
          this.loading = false;
        });
    },
    getFile() {
      this.loading = true;
      this.contentFile = [];
      let body = {
        path_file: this.selection[0].path,
      };
      axios
        .post("/server/logs/secure/get/logs", body)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              let data = response.data.data;
              if (data) {
                data = data.map((item) => {
                  item.timeMillis = new Date(item.timeMillis);
                  return item;
                });
                this.contentFile = data;
                this.contentFileFilter = data;
              }
            }
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            this.data = [];
          } else {
            console.log(error);
          }
        })
        .finally(() => {
          this.loading = false;
        });
    },
  },
  created() {
    this.getListFiles();
  },
};
</script>
